<?php
// $Id: session.php 2 2005-11-02 18:23:29Z skalpa $
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
// Author: Kazumi Ono (AKA onokazu)                                          //
// URL: http://www.myweb.ne.jp/, http://www.xoops.org/, http://jp.xoops.org/ //
// Project: The XOOPS Project                                                //
// ------------------------------------------------------------------------- //
/**
 * @package     kernel
 * 
 * @author	    Kazumi Ono	<onokazu@xoops.org>
 * @copyright	copyright (c) 2000-2003 XOOPS.org
 */


/**
 * Handler for a session
 * @package     kernel
 * 
 * @author	    Kazumi Ono	<onokazu@xoops.org>
 * @copyright	copyright (c) 2000-2003 XOOPS.org
 */
class XoopsSessionHandler
{

    /**
     * Database connection
     * 
     * @var	object
     * @access	private
     */
    var $db;

    /**
     * Constructor
     * 
     * @param	object  &$mf    reference to a XoopsManagerFactory
     * 
     */
    function XoopsSessionHandler(&$db)
    {
        $this->db =& $db;
    }

    /**
     * Open a session
     * 
     * @param	string  $save_path
     * @param	string  $session_name
     * 
     * @return	bool
     */
    function open($save_path, $session_name)
	{
        return true;
    }

    /**
     * Close a session
     * 
     * @return	bool
     */
    function close()
	{
        return true;
    }

    /**
     * Read a session from the database
     * 
     * @param	string  &sess_id    ID of the session
     * 
     * @return	array   Session data
     */
    function read($sess_id)
	{
        $sql = sprintf('SELECT sess_data FROM %s WHERE sess_id = %s', $this->db->prefix('session'), $this->db->quoteString($sess_id));
        if (false != $result = $this->db->query($sql)) {
            if (list($sess_data) = $this->db->fetchRow($result)) {
                return $sess_data;
            }
        }
        return '';
    }

    /**
     * Write a session to the database
     * 
     * @param   string  $sess_id
     * @param   string  $sess_data
     * 
     * @return  bool    
     **/
    function write($sess_id, $sess_data)
    {
	$sess_id = $this->db->quoteString($sess_id);
	list($count) = $this->db->fetchRow($this->db->query("SELECT COUNT(*) FROM ".$this->db->prefix('session')." WHERE sess_id=".$sess_id));
	//*** Start for XPHPBBI ********************************************************// by Alf - 23.02.2005
	global $isxphpbbi, $uid_xphpbbi, $issess, $xoopsConfig;
	if ( $isxphpbbi ) {
	    if (!defined('IN_PHPBB')) define('IN_PHPBB', true);
	    include (XOOPS_ROOT_PATH."/modules/xphpbbi/includes/constants.php");
	    $current_time = time();
	    $sess_exp     = $this->db->fetchArray($this->db->query("SELECT * FROM ".CONFIG_TABLE." WHERE config_name = 'session_length'"));
	    $time_exp_bb  = $sess_exp['config_value'] ? ($current_time - $sess_exp['config_value']) : ($current_time - 3600);
	    $sess_data    = $this->db->quoteString($sess_data);
	    $time_exp     = $xoopsConfig['session_expire']*60 < $sess_exp['config_value'] ? ($current_time - $xoopsConfig['session_expire']*60) : ($current_time - $sess_exp['config_value']);

	    if ( $count > 0 ){
		$sql = sprintf('UPDATE %s SET sess_updated = %u, sess_data = %s WHERE sess_id = %s', $this->db->prefix('session'), $current_time, $sess_data, $sess_id);
		$sql_ext = "UPDATE ".SESSIONS_TABLE_EXT." SET session_user_id = $uid_xphpbbi, session_logged_in = $issess, session_page = $sess_page WHERE sess_id = $sess_id";
	    } else {
		$res_exp_sess = $this->db->query("SELECT se.sess_id FROM ".SESSIONS_TABLE_EXT." se, ".SESSIONS_TABLE." s 
						WHERE s.sess_updated < '".$time_exp."' AND se.sess_id = s.sess_id");
		while ($row = $xoopsDB->fetchArray($res_exp_sess)) {
		    $this->db->queryF("DELETE FROM ".SESSIONS_TABLE_EXT." WHERE sess_id = '".$row['sess_id']."'");
		}
		$sql = sprintf('INSERT INTO %s (sess_id, sess_updated, sess_ip, sess_data) VALUES (%s, %u, %s, %s)', $this->db->prefix('session'), $sess_id, $current_time, $this->db->quoteString($_SERVER['REMOTE_ADDR']), $sess_data);
		$sql_ext = "INSERT INTO ".SESSIONS_TABLE_EXT." (sess_id, sess_ip, session_user_id, session_start, session_page, session_logged_in) VALUES ($sess_id, $sess_ip, $uid_xphpbbi, $current_time, 0, $issess)";
	    }
	    if (!$this->db->queryF($sql) && !$this->db->queryF($sql_ext)) {
        	return false;
            }else{
	        return true;
	    }
        } else {
	//*** End for XPHPBBI **********************************************************// by Alf - 23.02.2005
    	    if ( $count > 0 ) {
		$sql = sprintf('UPDATE %s SET sess_updated = %u, sess_data = %s WHERE sess_id = %s', $this->db->prefix('session'), time(), $this->db->quoteString($sess_data), $sess_id);
    	    } else {
		$sql = sprintf('INSERT INTO %s (sess_id, sess_updated, sess_ip, sess_data) VALUES (%s, %u, %s, %s)', $this->db->prefix('session'), $sess_id, time(), $this->db->quoteString($_SERVER['REMOTE_ADDR']), $this->db->quoteString($sess_data));
    	    }
	    if (!$this->db->queryF($sql)) {
        	return false;
            }else{
		return true;
	    }
	}
    }

    /**
     * Destroy a session
     * 
     * @param   string  $sess_id
     * 
     * @return  bool
     **/
    function destroy($sess_id)
    {
//*** Start for XPHPBBI ********************************************************// by Alf - 22.02.2005
	// XPHPBBI last visit
	global $isxphpbbi, $uid_xphpbbi, $usersess_xphpbbi;
	    if ( $isxphpbbi ) {
		if (!defined('IN_PHPBB')) define ('IN_PHPBB', 1);
    		$current_time = time();
    		$last_visit = ( $usersess_xphpbbi > 0 ) ? $usersess_xphpbbi : $current_time;
     		$this->db->queryF("UPDATE ".USERS_TABLE_EXT." SET user_lastvisit = $last_visit, user_session_time = $current_time WHERE uid = $uid_xphpbbi");
		$this->db->queryF("DELETE FROM ".SESSIONS_TABLE_EXT." WHERE sess_id=".$sess_id);
     	    }
//*** End for XPHPBBI **********************************************************// by Alf - 22.02.2005
		$sql = sprintf('DELETE FROM %s WHERE sess_id = %s', $this->db->prefix('session'), $this->db->quoteString($sess_id));
        if ( !$result = $this->db->queryF($sql) ) {
            return false;
        }
        return true;
    }

    /**
     * Garbage Collector
     * 
     * @param   int $expire Time in seconds until a session expires
	 * @return  bool
     **/
    function gc($expire)
    {
        $mintime = time() - intval($expire);
		$sql = sprintf('DELETE FROM %s WHERE sess_updated < %u', $this->db->prefix('session'), $mintime);
        return $this->db->queryF($sql);
    }
}
?>